public inbox for linux-kbuild@vger.kernel.org
 help / color / mirror / Atom feed
From: Eugeniu Rosca <eugeniu.m.rosca@gmail.com>
To: mmarek@suse.com, mpe@ellerman.id.au,
	kirill.shutemov@linux.intel.com, naveen.n.rao@linux.vnet.ibm.com,
	akpm@linux-foundation.org, sboyd@codeaurora.org,
	paul.gortmaker@windriver.com
Cc: linux-kbuild@vger.kernel.org, Eugeniu Rosca <eugeniu.m.rosca@gmail.com>
Subject: [PATCH] scripts/tags.sh: Exit gracefully if *tags tool not found
Date: Sun, 24 Apr 2016 18:42:00 +0200	[thread overview]
Message-ID: <1461516120-5600-1-git-send-email-eugeniu.m.rosca@gmail.com> (raw)

If the needed host utility is not found, current behavior is:

$> make cscope
  GEN     cscope
./scripts/tags.sh: line 140: cscope: command not found
$> make gtags
  GEN     gtags
./scripts/tags.sh: line 145: gtags: command not found
$> make tags
  GEN     tags
xargs: ctags: No such file or directory
sed: can't read tags: No such file or directory
Makefile:1509: recipe for target 'tags' failed
make: *** [tags] Error 2
$> make TAGS
  GEN     TAGS
xargs: etags: No such file or directory
sed: can't read TAGS: No such file or directory
Makefile:1509: recipe for target 'TAGS' failed
make: *** [TAGS] Error 2

This patch allows to exit gracefully in such a situation:

$> make cscope
  GEN     cscope
cscope - not installed?
$> make gtags
  GEN     gtags
gtags - not installed?
$> make tags
  GEN     tags
ctags - not installed?
$> make TAGS
  GEN     TAGS
etags - not installed?

Signed-off-by: Eugeniu Rosca <eugeniu.m.rosca@gmail.com>
---
 scripts/tags.sh | 11 +++++++++++
 1 file changed, 11 insertions(+)

diff --git a/scripts/tags.sh b/scripts/tags.sh
index f72f48f..e7f6125 100755
--- a/scripts/tags.sh
+++ b/scripts/tags.sh
@@ -289,6 +289,13 @@ xtags()
 	fi
 }
 
+# Check if a specific utility is accessible on the host
+tool_exists() {
+	[ -x "$(which $1 2> /dev/null)" ] || \
+		{ echo "$1 - not installed?" && return 1; }
+	return 0
+}
+
 # Support um (which uses SUBARCH)
 if [ "${ARCH}" = "um" ]; then
 	if [ "$SUBARCH" = "i386" ]; then
@@ -318,20 +325,24 @@ fi
 remove_structs=
 case "$1" in
 	"cscope")
+		tool_exists cscope || exit 0
 		docscope
 		;;
 
 	"gtags")
+		tool_exists gtags || exit 0
 		dogtags
 		;;
 
 	"tags")
+		tool_exists ctags || exit 0
 		rm -f tags
 		xtags ctags
 		remove_structs=y
 		;;
 
 	"TAGS")
+		tool_exists etags || exit 0
 		rm -f TAGS
 		xtags etags
 		remove_structs=y
-- 
2.7.4


             reply	other threads:[~2016-04-24 16:43 UTC|newest]

Thread overview: 5+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2016-04-24 16:42 Eugeniu Rosca [this message]
2016-04-25 12:35 ` [PATCH] scripts/tags.sh: Exit gracefully if *tags tool not found Michal Marek
2016-05-15 13:44   ` Eugeniu Rosca
2016-05-16  7:06     ` Michal Marek
2016-05-16 13:37       ` [PATCH v2] scripts/tags.sh: Handle missing {c,e,g}tags/cscope utilities Eugeniu Rosca

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1461516120-5600-1-git-send-email-eugeniu.m.rosca@gmail.com \
    --to=eugeniu.m.rosca@gmail.com \
    --cc=akpm@linux-foundation.org \
    --cc=kirill.shutemov@linux.intel.com \
    --cc=linux-kbuild@vger.kernel.org \
    --cc=mmarek@suse.com \
    --cc=mpe@ellerman.id.au \
    --cc=naveen.n.rao@linux.vnet.ibm.com \
    --cc=paul.gortmaker@windriver.com \
    --cc=sboyd@codeaurora.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox